package org.hisp.dhis.mobile.db;

import java.util.Vector;

import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import org.hisp.dhis.mobile.model.DataSet;
import org.hisp.dhis.mobile.util.SerializationUtil;

public class DataSetRecordStore
{
    public static final String DATASET_DB = "DATASET";

    public DataSetRecordStore()
    {
    }

    public Vector getAllDataSet()
        throws RecordStoreException
    {
        Vector dataSets = new Vector();
        RecordStore rs = null;
        RecordEnumeration re = null;
        try
        {
            rs = RecordStore.openRecordStore( DATASET_DB, true );
            re = rs.enumerateRecords( null, null, false );
            while ( re.hasNextElement() )
            {
                DataSet ds = new DataSet();
                SerializationUtil.deSerialize( ds, re.nextRecord() );
                dataSets.addElement( ds );
            }
        }
        catch ( Exception e )
        {
            e.printStackTrace();
            System.out.println( e.getMessage() );
        }
        finally
        {
            if ( re != null )
                re.destroy();
            if ( rs != null )
                rs.closeRecordStore();
        }
        return dataSets;
    }
}
