package org.hisp.dhis.mobile.db;

/*
 * Copyright (c) 2004-2010, University of Oslo All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met: * Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer. * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation and/or other materials provided with the
 * distribution. * Neither the name of the HISP project nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;

import javax.microedition.rms.RecordFilter;
import javax.microedition.rms.RecordStoreException;

import org.hisp.dhis.mobile.model.Model;

public class ModelFilter
    implements RecordFilter
{
    private Model model;

    private ByteArrayInputStream inputstream = null;

    private DataInputStream datainputstream = null;

    public ModelFilter( Model model )
    {
        this.model = model;
    }

    public boolean matches( byte[] suspect )
    {

        if ( model == null )
        {
            return false;
        }

        try
        {
            Model m = Model.fromBytes( suspect );
            return model.getId() == m.getId();
        }
        catch ( RecordStoreException e )
        {
            // FIXME
            e.printStackTrace();
            return false;
        }
        finally
        {
            close();
        }

    }

    public void close()
    {
        try
        {
            if ( inputstream != null )
            {
                inputstream.close();
            }
            if ( datainputstream != null )
            {
                datainputstream.close();
            }
        }
        catch ( Exception error )
        {
        }
    }
}
